kiss/kiss

1108 lines
35 KiB
Plaintext
Raw Normal View History

2019-09-11 10:21:56 -06:00
#!/bin/sh -ef
#
2019-09-10 23:54:45 -06:00
# This is a simple package manager written in POSIX 'sh' for use
# in KISS Linux (https://getkiss.org).
2019-08-19 11:07:50 -06:00
#
2019-09-10 23:54:45 -06:00
# This script runs with '-ef' meaning:
# '-e': Abort on any non-zero exit code.
# '-f': Disable globbing globally.
2019-06-29 14:38:35 -06:00
#
# [1] Warnings related to word splitting and globbing are disabled.
2019-09-10 23:54:45 -06:00
# All word splitting in this script is *safe* and intentional.
2019-06-29 14:38:35 -06:00
#
2019-09-10 23:54:45 -06:00
# Dylan Araps.
2019-06-13 08:48:08 -06:00
2019-09-21 11:22:56 -06:00
log() {
# Print a message prettily.
2019-09-21 12:32:03 -06:00
#
# This function uses the literal escape character (Ctrl+V+Escape) as
# a simple way of *safely* bypassing the escape sequence restrictions
# on 'printf %s'. Cheeky, I know.
#
# '\033[1;32m' Set text to color '2' and make it bold.
# '\033[m': Reset text formatting.
# '${3:-->}': If the 3rd argument is missing, set prefix to '->'.
# '${2:+[1;3Xm}': If the 2nd argument exists, set the text style of '$1'.
# '$((${#1}%5+1))': Color the package name based on its length.
# '${2:+[m}': If the 2nd argument exists, reset text formatting.
2019-09-21 12:10:25 -06:00
printf '\033[1;33m%s \033[m%s\033[m %s\n' \
2019-10-04 04:47:25 -06:00
"${3:-->}" "${2:+}$1${2:+}" "$2"
2019-09-21 11:22:56 -06:00
}
2019-06-13 08:48:08 -06:00
die() {
2019-06-28 15:26:43 -06:00
# Print a message and exit with '1' (error).
2019-09-21 11:22:56 -06:00
log "$1" "$2" "!>" >&2
2019-06-13 08:48:08 -06:00
exit 1
}
contains() {
# Check if a "string list" contains a word.
2019-11-29 03:16:48 -07:00
case " $1 " in *" $2 "*) return 0; esac; return 1
}
2019-09-22 05:35:07 -06:00
prompt() {
2019-09-22 05:37:39 -06:00
# Ask the user for some input.
2019-09-22 05:35:07 -06:00
log "Continue?: Press Enter to continue or Ctrl+C to abort here"
# POSIX 'read' has none of the "nice" options like '-n', '-p'
# etc etc. This is the most basic usage of 'read'.
# '_' is used as 'dash' errors when no variable is given to 'read'.
read -r _
}
2019-06-29 14:38:35 -06:00
pkg_lint() {
# Check that each mandatory file in the package entry exists.
2019-09-21 11:22:56 -06:00
log "$1" "Checking repository files"
2019-06-13 08:48:08 -06:00
repo_dir=$(pkg_find "$1")
2019-06-29 14:38:35 -06:00
2019-07-03 08:31:00 -06:00
cd "$repo_dir" || die "'$repo_dir' not accessible"
2019-09-21 11:22:56 -06:00
[ -f sources ] || die "$1" "Sources file not found"
[ -x build ] || die "$1" "Build file not found or not executable"
[ -s version ] || die "$1" "Version file not found or empty"
2019-06-29 14:38:35 -06:00
2019-08-19 11:05:48 -06:00
read -r _ release < version
2019-08-19 11:15:50 -06:00
[ "$release" ] || die "Release field not found in version file"
2019-06-18 02:05:15 -06:00
}
pkg_find() {
2019-06-28 15:26:43 -06:00
# Figure out which repository a package belongs to by
# searching for directories matching the package name
2019-06-29 14:38:35 -06:00
# in $KISS_PATH/*.
2019-08-19 12:45:19 -06:00
[ "$KISS_PATH" ] || die "\$KISS_PATH needs to be set"
2019-06-28 15:26:43 -06:00
2019-10-01 13:40:23 -06:00
# Turn the argument list into variables as we reset
# the list below.
query=$1
match=$2
# Find the repository containing a package.
2019-08-20 03:57:44 -06:00
# Searches installed packages if the package is absent
# from the repositories.
2019-09-20 08:54:12 -06:00
# See [1] at top of script.
# shellcheck disable=2046,2086
2019-11-12 18:02:58 -07:00
set -- $(IFS=:
find $KISS_PATH "$sys_db" -mindepth 1 -maxdepth 1 -name "$1")
2019-06-13 10:40:50 -06:00
2019-06-29 14:38:35 -06:00
# A package may also not be found due to a repository not being
# readable by the current user. Either way, we need to die here.
2019-10-01 13:40:23 -06:00
[ "$1" ] || die "Package '$query' not in any repository"
2019-06-13 10:40:50 -06:00
2019-10-01 13:40:23 -06:00
# Show all search results if called from 'kiss search', else
# print only the first match.
case $match in
all) printf '%s\n' "$@" ;;
*) printf '%s\n' "$1" ;;
esac
2019-06-13 10:40:50 -06:00
}
2019-06-29 14:38:35 -06:00
pkg_list() {
# List installed packages. As the format is files and
# directories, this just involves a simple for loop and
2019-06-29 14:38:35 -06:00
# file read.
# Change directories to the database. This allows us to
# avoid having to 'basename' each path. If this fails,
2019-06-29 14:38:35 -06:00
# set '$1' to mimic a failed glob which indicates that
# nothing is installed.
2019-09-10 06:38:26 -06:00
cd "$sys_db" 2>/dev/null || set -- "$sys_db/"\*
2019-06-29 14:38:35 -06:00
# Optional arguments can be passed to check for specific
# packages. If no arguments are passed, list all. As we
# loop over '$@', if there aren't any arguments we can
# just set the directory contents to the argument list.
[ "$1" ] || { set +f; set -f -- *; }
2019-06-29 14:38:35 -06:00
# If the 'glob' above failed, exit early as there are no
# packages installed.
2019-09-10 06:38:26 -06:00
[ "$1" = "$sys_db/"\* ] && return 1
2019-06-29 14:38:35 -06:00
2019-09-09 02:17:59 -06:00
# Loop over each package and print its name and version.
2019-06-29 14:38:35 -06:00
for pkg; do
2019-09-09 02:17:59 -06:00
[ -d "$pkg" ] || {
2019-08-19 11:15:50 -06:00
log "Package '$pkg' is not installed"
2019-06-29 14:38:35 -06:00
return 1
2019-09-09 02:17:59 -06:00
}
2019-06-13 08:48:08 -06:00
2019-09-10 07:56:44 -06:00
read -r version 2>/dev/null < "$pkg/version" || version=null
printf '%s\n' "$pkg $version"
2019-06-29 14:38:35 -06:00
done
2019-06-13 08:48:08 -06:00
}
pkg_sources() {
2019-06-29 14:38:35 -06:00
# Download any remote package sources. The existence of local
# files is also checked.
2019-09-21 11:22:56 -06:00
log "$1" "Downloading sources"
2019-09-10 01:56:14 -06:00
# Store each downloaded source in a directory named after the
# package it belongs to. This avoid conflicts between two packages
# having a source of the same name.
2019-08-20 04:05:34 -06:00
mkdir -p "$src_dir/$1" && cd "$src_dir/$1"
2019-06-29 14:38:35 -06:00
repo_dir=$(pkg_find "$1")
2019-06-13 08:48:08 -06:00
2019-11-16 12:53:41 -07:00
while read -r src _ || [ "$src" ]; do
2019-09-23 00:30:34 -06:00
# Remote source (cached).
if [ -f "${src##*/}" ]; then
log "$1" "Found cached source '${src##*/}'"
# Remote source.
elif [ -z "${src##*://*}" ]; then
curl "$src" -fLo "${src##*/}" || {
2019-09-23 00:30:34 -06:00
rm -f "${src##*/}"
die "$1" "Failed to download $src"
}
# Local source.
elif [ -f "$repo_dir/$src" ]; then
log "$1" "Found local file '$src'"
else
die "$1" "No local file '$src'"
fi
2019-06-29 14:38:35 -06:00
done < "$repo_dir/sources"
2019-06-13 08:48:08 -06:00
}
pkg_extract() {
# Extract all source archives to the build directory and copy over
2019-06-29 14:38:35 -06:00
# any local repository files.
2019-09-21 11:22:56 -06:00
log "$1" "Extracting sources"
2019-06-29 14:38:35 -06:00
repo_dir=$(pkg_find "$1")
2019-06-13 08:48:08 -06:00
2019-11-16 12:53:41 -07:00
while read -r src dest || [ "$src" ]; do
2019-09-10 02:20:05 -06:00
mkdir -p "$mak_dir/$1/$dest" && cd "$mak_dir/$1/$dest"
2019-06-29 14:38:35 -06:00
case $src in
# Only 'tar' archives are currently supported for extraction.
# Any other file-types are simply copied to '$mak_dir' which
# allows for manual extraction.
*://*.tar|*://*.tar.??|*://*.tar.???|*://*.tar.????|*://*.tgz)
tar xf "$src_dir/$1/${src##*/}" --strip-components 1 ||
die "$1" "Couldn't extract ${src##*/}"
;;
2019-09-23 00:30:34 -06:00
*)
# Local file.
if [ -f "$repo_dir/$src" ]; then
cp -f "$repo_dir/$src" .
2019-09-23 00:30:34 -06:00
# Remote file.
elif [ -f "$src_dir/$1/${src##*/}" ]; then
cp -f "$src_dir/$1/${src##*/}" .
else
die "$1" "Local file $src not found"
fi
;;
esac
2019-06-29 14:38:35 -06:00
done < "$repo_dir/sources"
2019-06-13 08:48:08 -06:00
}
2019-06-29 14:38:35 -06:00
pkg_depends() {
2019-09-15 00:31:57 -06:00
# Resolve all dependencies and generate an ordered list.
2019-06-29 14:38:35 -06:00
2019-09-14 07:12:30 -06:00
repo_dir=$(pkg_find "$1")
2019-06-29 14:38:35 -06:00
# This does a depth-first search. The deepest dependencies are
# listed first and then the parents in reverse order.
contains "$deps" "$1" || {
2019-09-15 00:39:39 -06:00
# Filter out non-explicit, aleady installed dependencies.
2019-09-16 00:26:15 -06:00
# Only filter installed if called from 'pkg_build()'.
2019-09-16 02:57:35 -06:00
[ "$pkg_build" ] && [ -z "$2" ] &&
(pkg_list "$1" >/dev/null) && return
2019-09-15 00:15:32 -06:00
2019-09-16 00:26:15 -06:00
# Recurse through the dependencies of the child packages.
2019-11-16 12:53:41 -07:00
while read -r dep _ || [ "$dep" ]; do
2019-09-14 01:23:58 -06:00
[ "${dep##\#*}" ] && pkg_depends "$dep"
2019-09-14 07:12:30 -06:00
done 2>/dev/null < "$repo_dir/depends" ||:
# After child dependencies are added to the list,
# add the package which depends on them.
2019-09-15 00:31:57 -06:00
[ "$2" = explicit ] || deps="$deps $1 "
}
2019-06-29 14:38:35 -06:00
}
2019-06-13 08:48:08 -06:00
pkg_strip() {
2019-06-29 14:38:35 -06:00
# Strip package binaries and libraries. This saves space on the
# system as well as on the tar-balls we ship for installation.
2019-06-29 14:38:35 -06:00
# Package has stripping disabled, stop here.
2019-11-09 02:45:23 -07:00
[ -f "$mak_dir/$pkg/nostrip" ] && return
2019-06-13 08:48:08 -06:00
2019-09-21 11:22:56 -06:00
log "$1" "Stripping binaries and libraries"
2019-06-29 14:38:35 -06:00
2019-08-30 11:09:55 -06:00
# Strip only files matching the below ELF types.
2019-08-30 10:48:00 -06:00
find "$pkg_dir/$1" -type f | while read -r file; do
2019-09-16 00:41:31 -06:00
case $(readelf -h "$file" 2>/dev/null) in
2019-11-29 03:16:48 -07:00
*" DYN "*) strip_opt=unneeded ;;
*" EXEC "*) strip_opt=all ;;
*" REL "*) strip_opt=debug ;;
2019-09-16 00:45:25 -06:00
*) continue
2019-08-30 10:48:00 -06:00
esac
# Suppress errors here as some binaries and libraries may
# fail to strip. This is OK.
2019-11-29 03:16:48 -07:00
strip "--strip-$strip_opt" "$file" 2>/dev/null ||:
2019-08-30 10:48:00 -06:00
done
2019-06-13 08:48:08 -06:00
}
pkg_fixdeps() {
# Dynamically look for missing runtime dependencies by checking
# each binary and library with 'ldd'. This catches any extra
# libraries and or dependencies pulled in by the package's
# build suite.
2019-09-21 11:22:56 -06:00
log "$1" "Checking for missing dependencies"
# Go to the directory containing the built package to
# simplify path building.
cd "$pkg_dir/$1/$pkg_db/$1"
# Make a copy of the depends file if it exists to have a
# reference to 'diff' against.
[ -f depends ] && cp -f depends depends-copy
2019-09-10 03:01:00 -06:00
# Get a list of binaries and libraries, false files
# will be found, however it's faster to get 'ldd' to check
# them anyway than to filter them out.
find "$pkg_dir/$1" -type f 2>/dev/null | while read -r file; do
# Run 'ldd' on the file and parse each line. The code
# then checks to see which packages own the linked
# libraries and it prints the result.
ldd "$file" 2>/dev/null | while read -r dep; do
# Skip lines containing 'ldd'.
[ "${dep##*ldd*}" ] || continue
# Extract the file path from 'ldd' output.
dep=${dep#* => }
dep=${dep% *}
# Traverse symlinks to get the true path to the file.
2019-09-10 06:38:26 -06:00
dep=$(readlink -f "$KISS_ROOT/${dep##$KISS_ROOT}")
# Figure out which package owns the file.
2019-09-10 06:38:26 -06:00
dep=$(set +f; grep -lFx "${dep##$KISS_ROOT}" "$sys_db/"*/manifest)
# Extract package name from 'grep' match.
dep=${dep%/*}
dep=${dep##*/}
case $dep in
# Skip listing these packages as dependencies.
2019-09-10 03:01:00 -06:00
musl|gcc|${PWD##*/}) ;;
*) printf '%s\n' "$dep" ;;
esac
done ||:
done >> depends-copy
# Remove duplicate entries from the new depends file.
# This remove duplicate lines looking *only* at the
# first column.
sort -u -k1,1 depends-copy > depends-new
# Display a 'diff' of the new dependencies agaisnt
# the old ones. '-N' treats non-existent files as blank.
diff -N depends depends-new ||:
# Do some clean up as this required a few temporary files.
mv -f depends-new depends
2019-08-21 05:08:34 -06:00
rm -f depends-copy
}
2019-10-07 06:07:26 -06:00
pkg_junk() (
# Optionally remove "junk" files from packages. This includes 'info'
# files, 'man' pages, gettext files, etc. This is configurable by the
2019-10-07 06:48:36 -06:00
# user.
2019-10-07 06:07:26 -06:00
#
# This funcion runs as a sub-shell to avoid having to 'cd' back to the
# prior directory before being able to continue.
cd "$pkg_dir/$1"
2019-10-07 06:48:36 -06:00
# Default list of directories and their contents to be removed from
# built packages. This default assumes a prefix of '/usr' though the
# user can further configure it to search whatever paths they desire.
2019-10-14 10:10:04 -06:00
rm=usr/share/doc:usr/share/gtk-doc:usr/share/info:usr/share/polkit-1
2019-10-15 07:52:45 -06:00
rm=$rm:usr/share/gettext:usr/share/locale:usr/share/bash-completion
2019-10-14 10:10:04 -06:00
rm=$rm:etc/bash_completion.d:usr/share/applications
rm=$rm:usr/share/zsh/site-functions:usr/share/zsh/vendor-completions
2019-10-07 06:07:26 -06:00
2019-10-07 06:48:36 -06:00
# Split the environment variable on ':' and turn it into an argument
# list. This works exactly like '$KISS_PATH'.
#
# Files which always conflict (such as usr/lib/charset.alias) and are
# uneeded should be removed regardless.
#
2019-10-07 06:48:36 -06:00
# shellcheck disable=2046,2086
2020-01-09 12:34:51 -07:00
{ IFS=:; set -- ${KISS_RM:-$rm} usr/lib/charset.alias; IFS=$old_ifs; }
2019-10-07 06:07:26 -06:00
2019-10-07 06:48:36 -06:00
# Loop over each junk entry and delete it if it exists.
for junk; do
2019-10-07 06:50:53 -06:00
[ -e "./$junk" ] && rm -rf "./$junk" &&
2019-10-07 06:48:36 -06:00
log "${PWD##*/}" "Removed $junk"
done ||:
2019-10-07 06:07:26 -06:00
)
2019-06-29 14:38:35 -06:00
pkg_manifest() (
# Generate the package's manifest file. This is a list of each file
# and directory inside the package. The file is used when uninstalling
# packages, checking for package conflicts and for general debugging.
2019-09-21 11:22:56 -06:00
log "$1" "Generating manifest"
2019-06-30 02:35:54 -06:00
# This funcion runs as a sub-shell to avoid having to 'cd' back to the
2019-06-29 14:38:35 -06:00
# prior directory before being able to continue.
cd "$pkg_dir/$1"
2019-09-21 10:03:11 -06:00
# find: Print all files and directories and append '/' to directories.
# sort: Sort the output in *reverse*. Directories appear *after* their
# contents.
# sed: Remove the first character in each line (./dir -> /dir).
2019-06-29 14:38:35 -06:00
find . -mindepth 1 -type d -exec printf '%s/\n' {} + -or -print |
2019-09-10 23:19:15 -06:00
sort -r | sed ss.ss > "$pkg_dir/$1/$pkg_db/$1/manifest"
2019-06-29 14:38:35 -06:00
)
2019-06-13 08:48:08 -06:00
pkg_tar() {
# Create a tar-ball from the built package's files.
# This tar-ball also contains the package's database entry.
2019-09-21 11:22:56 -06:00
log "$1" "Creating tar-ball"
2019-06-29 14:38:35 -06:00
# Read the version information to name the package.
read -r version release < "$(pkg_find "$1")/version"
2019-06-29 14:38:35 -06:00
2019-08-29 02:57:19 -06:00
# Create a tar-ball from the contents of the built package.
tar zpcf "$bin_dir/$1#$version-$release.tar.gz" -C "$pkg_dir/$1" . ||
2019-09-21 11:22:56 -06:00
die "$1" "Failed to create tar-ball"
2019-06-29 14:38:35 -06:00
2019-09-21 11:22:56 -06:00
log "$1" "Successfully created tar-ball"
2019-06-13 08:48:08 -06:00
}
2019-06-29 14:38:35 -06:00
pkg_build() {
# Build packages and turn them into packaged tar-balls. This function
2019-06-29 14:38:35 -06:00
# also checks checksums, downloads sources and ensure all dependencies
# are installed.
2019-09-16 02:57:35 -06:00
pkg_build=1
2019-06-17 01:18:36 -06:00
2019-09-13 12:25:33 -06:00
log "Resolving dependencies"
2019-09-13 15:20:33 -06:00
2019-09-15 01:42:18 -06:00
for pkg; do
contains "$explicit" "$pkg" || {
pkg_depends "$pkg" explicit
2019-09-13 12:43:23 -06:00
# Mark packages passed on the command-line
# separately from those detected as dependencies.
explicit="$explicit $pkg "
}
2019-09-13 12:43:23 -06:00
done
2019-09-13 12:25:33 -06:00
2019-09-13 15:20:21 -06:00
explicit_build=$explicit
2019-09-13 14:52:15 -06:00
2019-09-13 12:30:16 -06:00
# If an explicit package is a dependency of another explicit
# package, remove it from the explicit list as it needs to be
# installed as a dependency.
2019-09-13 12:25:33 -06:00
for pkg; do
2019-09-15 01:42:18 -06:00
# There's no better way to remove a word from a string in
# POSIX 'sh' sadly.
2019-09-15 01:42:18 -06:00
contains "$deps" "$pkg" &&
explicit=$(echo "$explicit" | sed "s/ $pkg / /g")
2019-09-13 12:25:33 -06:00
done
2019-09-20 08:54:12 -06:00
# See [1] at top of script.
# shellcheck disable=2046,2086
2019-09-15 00:15:32 -06:00
set -- $deps $explicit
2019-08-19 11:15:50 -06:00
log "Building: $*"
2019-07-11 00:14:17 -06:00
# Only ask for confirmation if more than one package needs to be built.
2019-09-22 05:37:09 -06:00
[ $# -gt 1 ] || [ "$pkg_update" ] && prompt
2019-07-11 00:14:17 -06:00
2020-01-11 04:46:57 -07:00
# Treat all packages as implicit if this is an update.
[ "$pkg_update" ] && explicit=
2019-08-19 11:15:50 -06:00
log "Checking to see if any dependencies have already been built"
log "Installing any pre-built dependencies"
# Install any pre-built dependencies if they exist in the binary
# directory and are up to date.
for pkg; do
2019-09-15 01:42:18 -06:00
# Don't check for a pre-built package if it was passed
2019-09-13 22:48:58 -06:00
# to KISS directly.
contains "$explicit_build" "$pkg" || {
# Figure out the version and release.
read -r version release < "$(pkg_find "$pkg")/version"
# Install any pre-built binaries if they exist.
2020-01-11 04:46:57 -07:00
# This calls 'args' to inherit a root check
# to 'su' to elevate permissions.
[ -f "$bin_dir/$pkg#$version-$release.tar.gz" ] && {
2019-09-21 11:22:56 -06:00
log "$pkg" "Found pre-built binary, installing"
(KISS_FORCE=1 args i "$bin_dir/$pkg#$version-$release.tar.gz")
# Remove the now installed package from the build
# list. No better way than using 'sed' in POSIX 'sh'.
2019-09-20 08:54:12 -06:00
# See [1] at top of script.
# shellcheck disable=2046,2086
set -- $(echo " $* " | sed "s/ $pkg / /")
}
2019-09-13 22:48:58 -06:00
}
done
2019-06-29 14:38:35 -06:00
for pkg; do pkg_lint "$pkg"; done
2019-07-03 08:29:57 -06:00
for pkg; do
# Ensure that checksums exist prior to building the package.
[ -f "$(pkg_find "$pkg")/checksums" ] || {
2019-09-21 11:22:56 -06:00
log "$pkg" "Checksums are missing"
2019-07-03 08:29:57 -06:00
# Instead of dying above, log it to the terminal. Also define a
# variable so we *can* die after all checksum files have been
# checked.
2019-09-10 02:26:34 -06:00
no_sums="$no_sums$pkg "
2019-07-03 08:29:57 -06:00
}
done
# Die here as packages without checksums were found above.
2019-09-10 02:26:34 -06:00
[ "$no_sums" ] && die "Checksums missing, run 'kiss checksum ${no_sums% }'"
2019-07-03 08:29:57 -06:00
2019-06-29 14:38:35 -06:00
for pkg; do pkg_sources "$pkg"; done
2019-09-16 00:26:15 -06:00
# Verify all package checksums. This is achieved by generating
# a new set of checksums and then comparing those with the old
# set.
for pkg; do
pkg_checksums "$pkg" | cmp -s - "$(pkg_find "$pkg")/checksums" || {
2019-09-21 11:22:56 -06:00
log "$pkg" "Checksum mismatch"
2019-09-16 00:26:15 -06:00
# Instead of dying above, log it to the terminal. Also define a
# variable so we *can* die after all checksum files have been
# checked.
mismatch="$mismatch$pkg "
}
done
2019-06-17 01:18:36 -06:00
2019-06-29 14:38:35 -06:00
# Die here as packages with differing checksums were found above.
2019-09-10 02:26:34 -06:00
[ "$mismatch" ] && die "Checksum mismatch with: ${mismatch% }"
2019-06-13 08:48:08 -06:00
2019-07-03 07:35:14 -06:00
# Finally build and create tarballs for all passed packages and
# dependencies.
2019-06-29 14:38:35 -06:00
for pkg; do
2020-01-03 00:10:41 -07:00
log "$pkg" "Building package ($((in = in + 1))/$#)"
2019-09-16 01:37:50 -06:00
pkg_extract "$pkg"
repo_dir=$(pkg_find "$pkg")
2019-06-17 01:18:36 -06:00
2019-06-29 14:38:35 -06:00
# Install built packages to a directory under the package name
# to avoid collisions with other packages.
2019-07-19 16:14:46 -06:00
mkdir -p "$pkg_dir/$pkg/$pkg_db"
2019-06-26 10:27:36 -06:00
2019-09-01 05:50:15 -06:00
# Move to the build directory.
2019-08-18 11:30:57 -06:00
cd "$mak_dir/$pkg"
2019-09-01 05:50:15 -06:00
2019-10-07 11:28:51 -06:00
log "$pkg" "Starting build"
2019-09-02 05:18:05 -06:00
# Call the build script.
2019-09-21 11:22:56 -06:00
"$repo_dir/build" "$pkg_dir/$pkg" || die "$pkg" "Build failed"
2019-06-29 14:38:35 -06:00
# Copy the repository files to the package directory.
# This acts as the database entry.
2019-10-22 02:54:04 -06:00
cp -LRf "$repo_dir" "$pkg_dir/$pkg/$pkg_db/"
2019-06-29 14:38:35 -06:00
2019-09-21 11:22:56 -06:00
log "$pkg" "Successfully built package"
2019-06-29 14:38:35 -06:00
# Create the manifest file early and make it empty.
# This ensure that the manifest is added to the manifest...
2019-07-19 16:14:46 -06:00
: > "$pkg_dir/$pkg/$pkg_db/$pkg/manifest"
2019-06-26 10:27:36 -06:00
pkg_strip "$pkg"
pkg_fixdeps "$pkg"
2019-10-07 06:07:26 -06:00
pkg_junk "$pkg"
pkg_manifest "$pkg"
pkg_tar "$pkg"
2019-06-26 10:27:36 -06:00
# Install only dependencies of passed packages.
2019-08-24 03:10:15 -06:00
# Skip this check if this is a package update.
contains "$explicit" "$pkg" && [ -z "$pkg_update" ] && continue
2019-08-24 03:10:15 -06:00
2019-09-21 11:22:56 -06:00
log "$pkg" "Needed as a dependency or has an update, installing"
(KISS_FORCE=1 args i "$pkg")
done
2019-06-29 14:38:35 -06:00
2019-08-24 03:18:08 -06:00
# End here as this was a system update and all packages have been installed.
[ "$pkg_update" ] && return
2019-08-19 11:15:50 -06:00
log "Successfully built package(s)"
# Turn the explicit packages into a 'list'.
2019-09-20 08:54:12 -06:00
# See [1] at top of script.
# shellcheck disable=2046,2086
2019-09-13 12:09:25 -06:00
set -- $explicit
# Only ask for confirmation if more than one package needs to be installed.
[ $# -gt 1 ] && {
2019-09-21 11:22:56 -06:00
log "Install built packages? [$*]"
2019-09-22 05:35:07 -06:00
prompt && {
args i "$@"
return
}
}
2019-09-22 05:35:07 -06:00
log "Run 'kiss i $*' to install the package(s)"
2019-06-29 14:38:35 -06:00
}
pkg_checksums() {
# Generate checksums for packages.
2019-09-11 00:33:09 -06:00
repo_dir=$(pkg_find "$1")
2019-06-29 14:38:35 -06:00
2019-11-16 12:53:41 -07:00
while read -r src _ || [ "$src" ]; do
2019-09-11 01:03:35 -06:00
# File is local to the package.
if [ -f "$repo_dir/$src" ]; then
src_path=$repo_dir/${src%/*}
# File is remote and was downloaded.
elif [ -f "$src_dir/$1/${src##*/}" ]; then
src_path=$src_dir/$1
# Die here if source for some reason, doesn't exist.
else
2019-09-21 11:22:56 -06:00
die "$1" "Couldn't find source '$src'"
2019-09-11 01:03:35 -06:00
fi
# An easy way to get 'sha256sum' to print with the 'basename'
# of files is to 'cd' to the file's directory beforehand.
(cd "$src_path" && sha256sum "${src##*/}") ||
2019-09-21 11:22:56 -06:00
die "$1" "Failed to generate checksums"
2019-07-21 05:21:47 -06:00
done < "$repo_dir/sources"
2019-06-29 14:38:35 -06:00
}
pkg_conflicts() {
# Check to see if a package conflicts with another.
2019-09-21 11:22:56 -06:00
log "$2" "Checking for package conflicts"
2019-06-29 14:38:35 -06:00
2019-11-20 17:45:52 -07:00
# Filter the tarball's manifest and select only files
# and any files they resolve to on the filesystem \
# (/bin/ls -> /usr/bin/ls).
2019-09-11 05:00:05 -06:00
tar xf "$1" -O "./$pkg_db/$2/manifest" | while read -r file; do
2019-11-20 17:45:52 -07:00
case $file in */) continue; esac
2019-11-20 17:45:52 -07:00
printf '%s\n' "$file"
2020-01-05 22:49:52 -07:00
readlink -f "$KISS_ROOT/$file" ||:
done > "$cac_dir/$pid-m"
p_name=$2
# Generate a list of all installed package manifests.
set +ef
set -f -- "$sys_db"/*/manifest
# Filter the manifest list and remove the previously
# installed version of the package if it exists.
for pkg; do
i_name=${pkg%/*}
i_name=${i_name##*/}
shift
2019-09-11 05:00:05 -06:00
2020-01-05 22:49:52 -07:00
[ "$p_name" = "$i_name" ] && continue
set -- "$@" "$pkg"
done
2019-09-11 05:00:05 -06:00
2020-01-05 22:49:52 -07:00
# Use 'grep' to list matching lines between the to
# be installed package's manifest and the above filtered
# list.
2019-11-20 17:45:52 -07:00
[ -s "$cac_dir/$pid-m" ] &&
2020-01-05 22:49:52 -07:00
grep -Fxf "$cac_dir/$pid-m" -- "$@" &&
die "Package '$p_name' conflicts with another package"
2019-09-11 05:00:05 -06:00
2020-01-05 22:49:52 -07:00
set -e
2019-06-13 08:48:08 -06:00
}
pkg_remove() {
2019-06-29 14:38:35 -06:00
# Remove a package and all of its files. The '/etc' directory
# is handled differently and configuration files are *not*
# overwritten.
2019-06-13 08:48:08 -06:00
# The package is not installed, don't do anything.
pkg_list "$1" >/dev/null || {
2019-09-21 11:22:56 -06:00
log "$1" "Not installed"
return
}
# Enable globbing.
set +f
# Make sure that nothing depends on this package.
2019-09-10 06:38:26 -06:00
[ "$2" = check ] && for file in "$sys_db/"*; do
# Check each depends file for the package and if it's
# a run-time dependency, append to the $required_by string.
grep -qFx "$1" "$file/depends" 2>/dev/null &&
2019-07-04 08:43:10 -06:00
required_by="$required_by'${file##*/}', "
done
2019-06-13 08:48:08 -06:00
# Disable globbing.
set -f
2019-09-21 11:22:56 -06:00
[ "$required_by" ] && die "$1" "Package is required by ${required_by%, }"
2019-07-26 10:21:44 -06:00
# Block being able to abort the script with 'Ctrl+C' during removal.
# Removes all risk of the user aborting a package removal leaving
2019-07-04 09:32:53 -06:00
# an incomplete package installed.
trap '' INT
while read -r file; do
# The file is in '/etc' skip it. This prevents the package
# manager from removing user edited configuration files.
[ "${file##/etc/*}" ] || continue
2019-06-26 10:27:36 -06:00
2019-09-10 06:38:26 -06:00
if [ -d "$KISS_ROOT/$file" ]; then
rmdir "$KISS_ROOT/$file" 2>/dev/null || continue
else
2019-09-13 15:28:30 -06:00
rm -f "$KISS_ROOT/$file"
fi
2019-09-10 06:38:26 -06:00
done < "$sys_db/$1/manifest"
2019-07-26 10:21:44 -06:00
# Reset 'trap' to its original value. Removal is done so
2019-07-04 09:32:53 -06:00
# we no longer need to block 'Ctrl+C'.
trap pkg_clean EXIT INT
2019-09-21 11:22:56 -06:00
log "$1" "Removed successfully"
2019-06-13 08:48:08 -06:00
}
2019-06-29 14:38:35 -06:00
pkg_install() {
# Install a built package tar-ball.
2019-06-13 23:58:09 -06:00
# Install can also take the full path to a tar-ball.
# We don't need to check the repository if this is the case.
if [ -f "$1" ] && [ -z "${1%%*.tar.gz}" ] ; then
tar_file=$1
2019-06-29 14:38:35 -06:00
else
# Read the version information to name the package.
2019-09-14 07:13:08 -06:00
read -r version release < "$(pkg_find "$1")/version"
2019-06-29 14:38:35 -06:00
# Construct the name of the package tarball.
tar_name=$1\#$version-$release.tar.gz
2019-06-29 14:38:35 -06:00
[ -f "$bin_dir/$tar_name" ] ||
2019-09-21 11:22:56 -06:00
die "Package '$1' has not been built, run 'kiss build $1'"
2019-06-29 14:38:35 -06:00
tar_file=$bin_dir/$tar_name
fi
2019-07-03 07:35:14 -06:00
# Figure out which package the tar-ball installs by checking for
# a database entry inside the tar-ball. If no database entry exists,
# exit here as the tar-ball is *most likely* not a KISS package.
pkg_name=$(tar tf "$tar_file" | grep -x "\./$pkg_db/.*/version") ||
die "'${tar_file##*/}' is not a valid KISS package"
2019-06-29 14:38:35 -06:00
pkg_name=${pkg_name%/*}
pkg_name=${pkg_name##*/}
2019-06-29 14:38:35 -06:00
pkg_conflicts "$tar_file" "$pkg_name"
2019-07-22 10:01:31 -06:00
mkdir -p "$tar_dir/$pkg_name"
2019-06-29 14:38:35 -06:00
# Extract the tar-ball to catch any errors before installation begins.
tar pxf "$tar_file" -C "$tar_dir/$pkg_name" ||
2019-09-21 11:22:56 -06:00
die "$pkg_name" "Failed to extract tar-ball"
2019-07-04 08:43:10 -06:00
2019-09-21 11:22:56 -06:00
log "$pkg_name" "Checking that all dependencies are installed"
2019-07-04 08:43:10 -06:00
# Make sure that all run-time dependencies are installed prior to
# installing the package.
[ -f "$tar_dir/$pkg_name/$pkg_db/$pkg_name/depends" ] &&
2019-09-14 08:52:33 -06:00
[ -z "$KISS_FORCE" ] &&
2019-11-16 12:53:41 -07:00
while read -r dep dep_type || [ "$dep" ]; do
[ "${dep##\#*}" ] || continue
[ "$dep_type" ] || pkg_list "$dep" >/dev/null ||
install_dep="$install_dep'$dep', "
done < "$tar_dir/$pkg_name/$pkg_db/$pkg_name/depends"
2019-07-04 08:43:10 -06:00
2019-09-21 11:22:56 -06:00
[ "$install_dep" ] && die "$1" "Package requires ${install_dep%, }"
2019-07-05 00:34:06 -06:00
2019-09-21 11:22:56 -06:00
log "$pkg_name" "Installing package incrementally"
# Block being able to abort the script with Ctrl+C during installation.
# Removes all risk of the user aborting a package installation leaving
# an incomplete package installed.
trap '' INT
2019-07-21 02:14:34 -06:00
# If the package is already installed (and this is an upgrade) make a
# backup of the manifest file.
2019-09-14 01:42:19 -06:00
old_manifest=$(cat "$sys_db/$pkg_name/manifest" 2>/dev/null ||:)
# This is repeated multiple times. Better to make it a function.
pkg_rsync() {
2019-10-11 13:19:08 -06:00
rsync --chown=root:root -WhHKa --no-compress "$1" --exclude /etc \
"$tar_dir/$pkg_name/" "$KISS_ROOT/"
}
2019-07-22 02:14:05 -06:00
# Install the package by using 'rsync' and overwrite any existing files
# (excluding '/etc/').
2019-09-11 11:22:58 -06:00
pkg_rsync --info=progress2
2019-07-21 02:14:34 -06:00
# If '/etc/' exists in the package, install it but don't overwrite.
[ -d "$tar_dir/$pkg_name/etc" ] &&
2019-09-11 11:04:16 -06:00
rsync --chown=root:root -WhHKa --no-compress --ignore-existing \
"$tar_dir/$pkg_name/etc" "$KISS_ROOT/"
2019-07-21 02:14:34 -06:00
# Remove any leftover files if this is an upgrade.
[ "$old_manifest" ] && {
printf '%s\n' "$old_manifest" |
grep -vFxf "$sys_db/$pkg_name/manifest" - |
2019-08-20 04:35:46 -06:00
while read -r file; do
# Skip deleting some leftover files.
case $file in
2019-09-11 02:45:37 -06:00
/etc/*|*bin/rm|*bin/busybox|*bin/rsync) continue
esac
2019-08-26 03:35:11 -06:00
file=$KISS_ROOT/$file
2019-09-10 06:38:26 -06:00
# Remove files.
if [ -f "$file" ] && [ ! -L "$file" ]; then
rm -f "$file"
2019-08-26 03:35:11 -06:00
# Remove file symlinks.
elif [ -L "$file" ] && [ ! -d "$file" ]; then
unlink "$file" ||:
2019-08-26 03:35:11 -06:00
# Skip directory symlinks.
2019-09-13 15:28:30 -06:00
elif [ -L "$file" ] && [ -d "$file" ]; then :
2019-08-13 03:21:03 -06:00
# Remove directories if empty.
elif [ -d "$file" ]; then
rmdir "$file" 2>/dev/null ||:
fi
done ||:
}
2019-06-29 14:38:35 -06:00
# Install the package again to fix any non-leftover files being
# removed above.
pkg_rsync -v ||:
pkg_rsync -v ||:
2019-07-22 02:01:37 -06:00
# Reset 'trap' to its original value. Installation is done so
# we no longer need to block 'Ctrl+C'.
trap pkg_clean EXIT INT
2019-09-20 10:53:58 -06:00
if [ -x "$sys_db/$pkg_name/post-install" ]; then
2019-09-21 11:22:56 -06:00
log "$pkg_name" "Running post-install script"
"$sys_db/$pkg_name/post-install" ||:
2019-09-20 10:53:58 -06:00
fi
2019-06-29 14:38:35 -06:00
2019-09-21 11:22:56 -06:00
log "$pkg_name" "Installed successfully"
2019-06-13 08:48:08 -06:00
}
2019-06-29 14:38:35 -06:00
pkg_updates() {
# Check all installed packages for updates. So long as the installed
# version and the version in the repositories differ, it's considered
# an update.
2019-08-19 11:15:50 -06:00
log "Updating repositories"
# Create a list of all repositories.
2019-09-20 08:54:12 -06:00
# See [1] at top of script.
# shellcheck disable=2046,2086
{ IFS=:; set -- $KISS_PATH; IFS=$old_ifs; }
# Update each repository in '$KISS_PATH'. It is assumed that
# each repository is 'git' tracked.
for repo; do
2019-08-14 03:58:14 -06:00
cd "$repo"
# Go to the root of the repository (if it exists).
cd "$(git rev-parse --show-toplevel 2>/dev/null)" 2>/dev/null ||:
[ -d .git ] || {
2019-10-04 04:47:25 -06:00
log "$repo" " "
printf '%s\n' "Not a git repository, skipping."
2019-08-14 03:58:14 -06:00
continue
}
[ "$(git remote 2>/dev/null)" ] || {
2019-10-04 04:47:25 -06:00
log "$repo" " "
printf '%s\n' "No remote, skipping."
continue
}
contains "$repos" "$PWD" || {
repos="$repos $PWD "
2019-08-14 03:58:14 -06:00
2019-10-04 04:47:25 -06:00
# Display a tick if signing is enabled for this
# repository.
case $(git config merge.verifySignatures) in
true) signed='[signed ✓]' ;;
*) signed= ;;
esac
log "$PWD" "$signed "
2019-08-14 03:58:14 -06:00
if [ -w "$PWD" ]; then
git fetch
git merge
else
2019-09-21 11:22:56 -06:00
log "$PWD" "Need root to update"
if command -v sudo >/dev/null; then
sudo git fetch
sudo git merge
else
su -c 'git fetch && git merge'
fi
fi
}
done
2019-08-19 11:15:50 -06:00
log "Checking for new package versions"
# Enable globbing.
set +f
2019-09-10 06:38:26 -06:00
for pkg in "$sys_db/"*; do
pkg_name=${pkg##*/}
2019-06-29 14:38:35 -06:00
# Read version and release information from the installed packages
# and repository.
read -r db_ver db_rel < "$pkg/version"
read -r re_ver re_rel < "$(pkg_find "$pkg_name")/version"
2019-06-29 14:38:35 -06:00
# Compare installed packages to repository packages.
2019-07-11 00:14:17 -06:00
[ "$db_ver-$db_rel" != "$re_ver-$re_rel" ] && {
printf '%s\n' "$pkg_name $db_ver-$db_rel ==> $re_ver-$re_rel"
2019-09-10 03:35:25 -06:00
outdated="$outdated$pkg_name "
2019-07-11 00:14:17 -06:00
}
2019-06-13 08:48:08 -06:00
done
2019-07-11 00:14:17 -06:00
# If the package manager has an update, handle it first.
contains "$outdated" kiss && {
2019-09-21 11:22:56 -06:00
log "Detected package manager update"
log "The package manager will be updated first"
2019-09-22 05:50:10 -06:00
prompt
pkg_build kiss
args i kiss
2019-09-21 11:22:56 -06:00
log "Updated the package manager"
log "Re-run 'kiss update' to update your system"
exit 0
}
# Disable globbing.
set -f
2019-07-11 00:14:17 -06:00
# End here if no packages have an update.
[ "$outdated" ] || {
2019-08-19 11:15:50 -06:00
log "Everything is up to date"
2019-07-11 00:14:17 -06:00
return
}
2019-09-10 03:35:25 -06:00
log "Packages to update: ${outdated% }"
# Tell 'pkg_build' to always prompt before build.
2019-08-24 03:10:15 -06:00
pkg_update=1
2019-07-11 00:14:17 -06:00
2019-07-26 10:56:22 -06:00
# Build all packages requiring an update.
2019-09-20 08:54:12 -06:00
# See [1] at top of script.
# shellcheck disable=2046,2086
2019-09-10 03:35:25 -06:00
pkg_build $outdated
2019-08-24 03:18:08 -06:00
log "Updated all packages"
2019-06-13 08:48:08 -06:00
}
2019-06-29 14:38:35 -06:00
pkg_clean() {
# Clean up on exit or error. This removes everything related
# to the build.
2019-09-20 10:53:58 -06:00
[ "$KISS_DEBUG" != 1 ] || return
2019-06-13 08:48:08 -06:00
# Block 'Ctrl+C' while cache is being cleaned.
trap '' INT
2019-09-11 05:00:05 -06:00
# Remove temporary items.
2019-09-11 02:30:44 -06:00
rm -rf -- "$mak_dir" "$pkg_dir" "$tar_dir" "$cac_dir/$pid-m"
2019-06-29 14:38:35 -06:00
}
2019-06-15 00:19:20 -06:00
2019-06-29 14:38:35 -06:00
args() {
# Parse script arguments manually. POSIX 'sh' has no 'getopts'
# or equivalent built in. This is rather easy to do in our case
# since the first argument is always an "action" and the arguments
# that follow are all package names.
2019-08-19 12:45:19 -06:00
action=$1
2019-09-10 07:56:44 -06:00
# 'dash' exits on error here if 'shift' is used and there are zero
# arguments despite trapping the error ('|| :').
shift "$(($# > 0 ? 1 : 0))"
2019-08-19 12:45:19 -06:00
2019-10-01 13:34:34 -06:00
# Unless this is a search, sanitize the user's input. The call to
# 'pkg_find()' supports basic globbing, ensure input doesn't expand
# to anything except for when this behavior is needed.
#
# This handles the globbing characters '*', '!', '[' and ']' as per:
# https://pubs.opengroup.org/onlinepubs/009695399/utilities/xcu_chap02.html
2019-10-01 13:34:34 -06:00
[ "$action" != search ] && [ "$action" != s ] &&
2019-10-01 13:58:19 -06:00
case $@ in
*'*'*|*'!'*|*'['*|*']'*)
2019-10-01 13:58:19 -06:00
die "Arguments contain invalid characters: '!*[]'"
2019-10-01 13:34:34 -06:00
;;
esac
2019-08-19 12:45:19 -06:00
# Parse some arguments earlier to remove the need to duplicate code.
case $action in
2019-08-21 05:00:50 -06:00
c|checksum|s|search)
2019-08-19 12:45:19 -06:00
[ "$1" ] || die "'kiss $action' requires an argument"
;;
i|install|r|remove)
[ "$1" ] || die "'kiss $action' requires an argument"
# Rerun the script with 'su' if the user isn't root.
# Cheeky but 'su' can't be used on shell functions themselves.
2019-08-20 03:57:44 -06:00
[ "$(id -u)" = 0 ] || {
if command -v sudo >/dev/null; then
sudo -E KISS_FORCE="$KISS_FORCE" kiss "$action" "$@"
else
su -pc "KISS_FORCE=$KISS_FORCE kiss $action $*"
fi
2019-08-20 03:57:44 -06:00
return
}
2019-08-19 12:45:19 -06:00
;;
esac
2019-06-29 14:38:35 -06:00
# Actions can be abbreviated to their first letter. This saves
2019-09-09 02:31:31 -06:00
# keystrokes once you memorize the commands.
2019-08-19 12:45:19 -06:00
case $action in
b|build)
# If no arguments were passed, rebuild all packages.
[ "$1" ] || {
2019-09-10 06:38:26 -06:00
cd "$sys_db" || die "Failed to find package db"
2019-07-13 16:18:07 -06:00
# Use a glob after 'cd' to generate a list of all installed
# packages based on directory names.
set +f; set -f -- *
2019-07-13 16:18:07 -06:00
# Undo the above 'cd' to ensure we stay in the same location.
cd - >/dev/null
}
2019-06-29 14:38:35 -06:00
pkg_build "$@"
;;
2019-08-21 05:00:50 -06:00
c|checksum)
2019-06-29 14:38:35 -06:00
for pkg; do pkg_lint "$pkg"; done
for pkg; do pkg_sources "$pkg"; done
2019-07-21 05:21:47 -06:00
for pkg; do
pkg_checksums "$pkg" > "$(pkg_find "$pkg")/checksums"
2019-06-29 14:38:35 -06:00
2019-09-21 11:22:56 -06:00
log "$pkg" "Generated checksums"
2019-07-21 05:21:47 -06:00
done
2019-06-29 14:38:35 -06:00
;;
2019-08-19 12:45:19 -06:00
i|install)
2019-09-15 00:31:57 -06:00
# Create a list of each package's dependencies.
for pkg; do
case $pkg in
*.tar.gz) deps="$deps $pkg " ;;
*) pkg_depends "$pkg" install
esac
done
# Filter the list, only installing explicit packages.
# The purpose of these two loops is to order the
# argument list based on dependence.
for pkg in $deps; do
2019-09-20 10:53:58 -06:00
! contains "$*" "$pkg" || pkg_install "$pkg"
2019-09-15 00:31:57 -06:00
done
2019-06-29 14:38:35 -06:00
;;
2019-08-19 12:45:19 -06:00
r|remove)
2019-08-19 11:15:50 -06:00
log "Removing packages"
2019-09-15 00:31:57 -06:00
# Create a list of each package's dependencies.
for pkg; do pkg_depends "$pkg" remove; done
# Reverse the list of dependencies filtering out anything
# not explicitly set for removal.
for pkg in $deps; do
contains "$*" "$pkg" && remove_pkgs="$pkg $remove_pkgs"
done
for pkg in $remove_pkgs; do
pkg_list "$pkg" >/dev/null ||
2019-09-21 11:22:56 -06:00
die "$pkg" "Not installed"
2019-08-31 07:01:17 -06:00
pkg_remove "$pkg" "${KISS_FORCE:-check}"
done
2019-06-29 14:38:35 -06:00
;;
2019-08-19 12:45:19 -06:00
l|list)
2019-06-29 14:38:35 -06:00
pkg_list "$@"
;;
2019-08-19 12:45:19 -06:00
u|update)
2019-06-29 14:38:35 -06:00
pkg_updates
;;
2019-08-19 12:45:19 -06:00
s|search)
2019-10-01 13:40:23 -06:00
for pkg; do pkg_find "$pkg" all; done
2019-07-13 14:31:00 -06:00
;;
2019-08-19 12:45:19 -06:00
v|version|-v|--version)
2020-01-10 09:16:46 -07:00
log kiss 0.57.0
2019-06-29 14:38:35 -06:00
;;
2019-08-19 12:45:19 -06:00
h|help|-h|--help|'')
2019-11-16 08:53:53 -07:00
log 'kiss [b|c|i|l|r|s|u|v] [pkg] [pkg] [pkg]'
2019-09-21 11:22:56 -06:00
log 'build: Build a package'
log 'checksum: Generate checksums'
log 'install: Install a package'
log 'list: List installed packages'
log 'remove: Remove a package'
log 'search: Search for a package'
log 'update: Check for updates'
2019-10-14 09:22:51 -06:00
log 'version: Package manager version'
2019-06-29 14:38:35 -06:00
;;
2019-07-24 16:33:12 -06:00
2019-08-19 12:45:19 -06:00
*) die "'kiss $action' is not a valid command" ;;
2019-06-13 08:48:08 -06:00
esac
}
main() {
2019-07-19 08:37:25 -06:00
# Set the location to the repository and package database.
2019-09-10 06:38:26 -06:00
pkg_db=var/db/kiss/installed
2019-07-19 08:37:25 -06:00
2019-06-29 14:38:35 -06:00
# The PID of the current shell process is used to isolate directories
# to each specific KISS instance. This allows multiple package manager
# instances to be run at once. Store the value in another variable so
# that it doesn't change beneath us.
pid=${KISS_PID:-$$}
2019-06-13 09:11:59 -06:00
# Store the original value of IFS so we can revert back to it if the
# variable is ever changed.
old_ifs=$IFS
2019-06-29 14:38:35 -06:00
# Catch errors and ensure that build files and directories are cleaned
# up before we die. This occurs on 'Ctrl+C' as well as success and error.
2019-06-29 14:38:35 -06:00
trap pkg_clean EXIT INT
2019-06-13 08:48:08 -06:00
2019-09-10 06:43:34 -06:00
# This allows for automatic setup of a KISS chroot and will
# do nothing on a normal system.
mkdir -p "${sys_db:=$KISS_ROOT/$pkg_db}" 2>/dev/null ||:
2019-07-03 07:35:14 -06:00
# Create the required temporary directories and set the variables
# which point to them.
2019-09-10 06:38:26 -06:00
mkdir -p "${cac_dir:=$KISS_ROOT${XDG_CACHE_HOME:-$HOME/.cache}/kiss}" \
2019-07-21 04:10:51 -06:00
"${mak_dir:=$cac_dir/build-$pid}" \
"${pkg_dir:=$cac_dir/pkg-$pid}" \
"${tar_dir:=$cac_dir/extract-$pid}" \
"${src_dir:=$cac_dir/sources}" \
"${bin_dir:=$cac_dir/bin}" \
2019-08-19 11:15:50 -06:00
|| die "Couldn't create cache directories"
2019-07-03 07:35:14 -06:00
2019-06-13 08:48:08 -06:00
args "$@"
}
main "$@"